exec("./extraResources.cs");


if (!isObject(IconSet)) {
	$IconSet = new SimSet(IconSet);
}

if (isFile("config/icons/users.cs")) {
	echo("Loading saved user icons...");
	exec("config/icons/users.cs");
}

function registerAllIcons() {
	echo("");
	echo("Registering all icons...");

	%loc = "config/icons/*.png";
	%registeredNew = 0;
	for (%dir = findFirstFile(%loc); %dir !$= ""; %dir = findNextFile(%loc)) {
		// echo("DIR:" SPC %dir);
		%pos1 = strLastPos(%dir, "/")+1;
		%pos2 = strLen(%dir);
		%name = getSubStr(%dir, %pos1, %pos2 - %pos1 - 4);
		%name = stripChars(%name, "!@#$%^&*(){}[]|/|\\;:'\"<>,.?`~+-=");
		%name = strReplace(%name, " ", "_");
		// echo("NAME:" SPC %name);

		if (isObject("Icon" @ %name @ "Object")) {
			echo("Icon \"" @ %name @ "\" exists, skipping...");
			continue;
		}

		echo("Registered chat icon: " @ %name);

		%obj = new ScriptObject("Icon" @ %name @ "Object") {
			bitmap = "<bitmap:config/icons/" @ %name @ ">";
			name = %name;
		};
		addExtraResource(%dir);
		IconSet.add(%obj);
	}
}

function serverCmdSetIcon(%cl, %i1, %i2, %i3, %i4, %i5, %i6) {
	%iconName = trim(%i1 SPC %i2 SPC %i3 SPC %i4 SPC %i5 SPC %i6);
	%iconName = strReplace(%iconName, " ", "_");

	if (%iconName $= "") {
		serverCmdListIcons(%cl);
		return;
	} else if (%iconName $= "None") {
		$IconObject_[%cl.bl_id] = "";
		messageClient(%cl, '', "\c5Icon removed!");
		return;
	}

	if (!isObject("Icon" @ %iconName @ "Object")) {
		messageClient(%cl, '', "\c5Icon \"" @ %iconName @ "\" doesn't exist! /listIcons to see available icons");
		return;
	} else {
		$IconObject_[%cl.bl_id] = "Icon" @ %iconName @ "Object";
		messageClient(%cl, '', "\c6Icon set to \c3" @ %iconName @ "\c6! " @ $IconObject_[%cl.bl_id].bitmap
			);
	}
	export("$IconObject_*", "config/icons/users.cs");
}

function serverCmdListIcons(%cl) {
	if (!isObject(IconSet)) {
		error("Error: serverCmdListIcons: IconSet doesn't exist!");
		messageClient(%cl, '', "Error: serverCmdListIcons: IconSet doesn't exist!");
		return;
	}

	messageClient(%cl, '', "\c6Icon list:");

	for (%i = 0; %i < IconSet.getCount(); %i++) {
		%obj = IconSet.getObject(%i);
		messageClient(%cl, '', "\c3" @ %obj.name @ "\c6 - " @ %obj.bitmap);
	}
}

function strLastPos(%str, %search, %offset) {
	if(%offset > 0)
		%pos = %offset;
	else {
		%str = getSubStr(%str, 0, strLen(%str) + %offset);
		%pos = 0;
	}
	%lastPos = -1;
	while((%pos = strPos(%str, %search, %pos+1)) > 0) {
		%lastPos = %pos;
		if(%break++ >= 500) //Pretty sure strings have a max length shorter than this, should be fine
			return -2;
	}
	return %lastPos;
}

package ChatIconsPackage {
	function serverCmdMessageSent(%cl, %msg) {
		if (isObject($IconObject_[%cl.bl_id])) {
			%pre = %cl.clanPrefix;
			echo(%clanPrefix);
			%cl.clanPrefix = $IconObject_[%cl.bl_id].bitmap SPC %pre;

			parent::serverCmdMessageSent(%cl, %msg);

			%cl.clanPrefix = %pre;
			echo(%clanPrefix);
		} else {
			parent::serverCmdMessageSent(%cl, %msg);
		}
	}
};
activatePackage(ChatIconsPackage);

registerAllIcons();